var gui=require('nw.gui');

function loginManager(){
    
    this.BindLoginEventHandlers = function BindLoginEventHandlers(){
        $("#appQuit").bind("click", function(){
          gui.App.quit();
        });
        
		// Click on Login Button
		
		$("#LoginButton").bind('click', function( event ){
			// Even managing click on login button
			// gets username, password and server, checks it
			// and stores in session.
			
			username=$("#input_username").val();
			password=$("#input_password").val();
			server=$("#input_server").val();
			
			sessionStorage.username = username;
			sessionStorage.password = password;
			sessionStorage.server = server;
			
			// Going to main window
			login();
		});
	}	
}



function login() {
	
	$("body").addClass("CursorWaiting");
	
	$.xmlrpc({
			url: 'https://'+sessionStorage.server+':9779',
			methodName: 'validate_user',
			params: [sessionStorage.username , sessionStorage.password],
			success: function(response,status,jqXHR){
				//$("body").removeClass("CursorWaiting");
				groups=response[0][1];				
				if ((groups.indexOf('adm')!=-1)||(groups.indexOf('admins')!=-1)||(groups.indexOf('teachers')!=-1)) {
					// Check if it is a LMD Server
					//checkServerVersion();
					window.location="main.html";
				} else{
					$("#input_password").addClass("wrong_pass");
					$("#input_username").addClass("wrong_pass");
                    $("#msg_err").attr("data-content", i18n.gettext("Username.Pass.Wrong"));
                    $("#msg_err").snackbar("show");
				}
			},
			error: function(jqXHR, status, error) {
				//alert("Status: "+status+"\nError: N4d server is down"+error);
                $("#msg_err").attr("data-content", i18n.gettext("N4d.Error.Connection"));
                $("#msg_err").snackbar("show");
			}
		})
}

$(document).ready(function() {
	var lm = new loginManager();
	var fs = require('fs');
	var path = require('path');
	
	lm.BindLoginEventHandlers();
	
	// Setting content and aspect of GUI elements
	var home = process.env.HOME;
	$("#LoginButton").append("Login");
	// $("button").button();
	if(fs.existsSync(path.join(home,".lmd-manager.config"))) {
		var output = fs.readFileSync(path.join(home,".lmd-manager.config"));
		var content = JSON.parse(output);
		$("#input_username").val(content['user']);
		$("#input_password").val(content['pass']);
		$("#input_server").val(content['server']);
		$("#input_password").focus();	
		}
	else{
		
		$("#input_username").val(process.env.USER);
		$("#input_password").focus();
	}
	 $("#input_password").bind('keydown',function (e) {
		
		if (e.which==13) {
			e.preventDefault();
			username=$("#input_username").val();
			password=$("#input_password").val();
			server=$("#input_server").val();
			sessionStorage.username = username;
			sessionStorage.password = password;
			sessionStorage.server = server;
			
			//alert(username+" "+password);
			login();
		}
        
    });


    $.material.init();

	
	
})

